#!/usr/local/bin/perl

# Name: Form.cgi
# Author: Dave Doyle <doyle@cs.umn.edu>
# 
# Version: 1.0
# Last Modified: 8/25/97
#
# Purpose: Creates forms for students to be able to evaluate their
# instructors
#

$| = 1;             #flush the buffer
print "Content-type: text/html\n\n";

&require_supporting_libraries (__FILE__, __LINE__,
			       "./Library/cgi-lib.pl");
###################################################################
#                           Local Variables                       #
###################################################################
           #
$start_url = "http://www.cs.umn.edu/\~doyle/8110";
$support_email = "doyle\@cs.umn.edu";
$end_url = "http://www.cs.umn.edu/~doyle/8110/done.html";
$applet_base = "Shoot";
@Fsections = ("Overview","Instructor","Work/Tests","Class","Text");

###################################################################
&ReadParse(*form_data);
#print PrintVariables(%form_data);


           # The next part shouldn't be needed, but in case the front
           # page is not written correctly, this should fix it.
if ($form_data{'menu_choice'} ne "") {
    $menu_choice = $form_data{'menu_choice'};
}
else
{
    $menu_choice = "Overview";
}

%Done_Data =();
###################################################################
           #
           # First, check for missing information
           # All information must be filled in for this to work, but
           # since most information has no choice but to be filled 
           # in, we only need to check 2 things
           #

           # check for missing information
if ((($form_data{'class_no'} eq "") && ($form_data{'class_name'} eq "")) || 
    ($form_data{'id_no'} eq ""))
{
           # Make them try again
    &generic_header("Error: Missing Data");
    print qq~
    <meta http-equiv="refresh" content="5; url=$start_url">

    Please fill in your class number and school ID before continuing.<p>~;

    if   ($form_data{'id_no'} eq "")
    {
	print qq~
This information is completely anonymous, your ID number is 
required by this program for statistical purposes only.  Your information 
will NEVER be released to the instructor or administration.<p>\n~;
    }
    &generic_footer;
    exit;
}
           #
           # all necessary information here, put it in the correct format
else 
{
    &fix_data;
}

           # menu choices, states which form to load
if ($menu_choice eq "Shoot") {   #shooting applet
    &get_db_data; 
    &Shoot_form; }
elsif ($menu_choice eq "Overview") { #forms
    &get_db_data; 
    &overview_form; }
elsif ($menu_choice eq "Instructor") {
    &instructor_form; }
elsif ($menu_choice eq "Work/Tests") {
    &hw_form; }
elsif ($menu_choice eq "Class") {
    &class_form; }
elsif ($menu_choice eq "Text") {
    &text_form; }
elsif ($menu_choice eq "Finish") {
    &end_form; }
elsif ($menu_choice eq "Submit Data") {
    &submit_it; }
else
{
    print "Eeeek, you shouldn't be able to see this!!!";
}



####################################################################### 
#                               Overview Form                         #
#######################################################################   
sub Shoot_form
{
    print qq~
    <HTML>
    <HEAD><TITLE>Tell your instructor</TITLE></HEAD>
    <BODY bgcolor=#ffffff>
    <P>
    <h1><center>Show your instructor how you feel</center></h1>
    <p>

    This applet is designed to give weekly feedback about an instructor.  All
    results due to this are compiled together and will be presented as a sum
    total of all entries.
    <p>
    Click on "rotten fruit" or "gold star" to show whether you are
    pleased with your instructor or not.  Then, click on the instructor''s
    photo as many times are you feel you need to.  When you are done, click on
    "done" and your anonymous results will be added to the rest.
    <p>

    To leave more specific information, explaining <b>why</b> you feel the way
    you do, feel free to click any checkboxes that match your feeling.
    <p>

    <APPLET CODE="Shoot.class" CODEBASE="./$applet_base" WIDTH=640 HEIGHT=450>
    <PARAM NAME=Instructor value="$prof_pic_name">
    <PARAM NAME=GoHereAfter value="$end_url">
    </APPLET>
    </BODY>
    </HTML>~;

}


####################################################################### 
#                               Overview Form                         #
#######################################################################   
           #
           # This first sheet will accomplish 2 things
           # 1) goes out and grabs information from the database
           # 2) pushes forth a form to fill out.  Should get info behind
           # scenes but will need to use temp files -- ugh!
           #
sub overview_form 
{
    &generic_header("Overview of $class_name");
    print qq~

    <CENTER>
    <IMG SRC="../lines/ruler_li.gif"><br>
    <H1>Overview of $class_name</H1><P>
    <TABLE>
    <TR><TD colspan=2><font size+1><b><u>SELF</u></b></font>
    </td></tr>
    <TR><TD>
	What was your ability in the subject before the class?
    </TD><TD>
    <select name="o[1]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">None</option>
    </select></td></TR>

    <TR><TD>
	What was your ability in subject after the course?
    </TD><TD>
    <select name="o[2]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">None</option>
    </select></td></TR>

    <TR><TD>
	How motivated were you to learn?
    </TD><TD>
    <select name="o[3]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">A lot</option>
      <OPTION value="4">Some</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	How much did you learn?
    </TD><TD>
    <select name="o[4]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">A lot</option>
      <OPTION value="4">Some</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	Do you feel you learned as much as you could have?
    </TD><TD>
    <select name="o[5]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="4">Close to it</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	How much did you enjoy the class?
    </TD><TD>
    <select name="o[6]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">A lot</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	How much time did you spend on it per week?
    </TD><TD>
    <INPUT TYPE=text name="o[7]" size=3> hours
    </td></TR>
    <TR><TD colspan=2><hr width=50%>
	<font size+1><b><u>INSTRUCTOR</u></b></font>
    </td></tr>

    <TR><TD>
	Rate the instructor''s overall teaching ability
    </TD><TD>
    <select name="o[8]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
    </select></td></TR>

    <TR><TD>
	Rate their knowledge of the subject matter
    </TD><TD>
    <select name="o[9]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
    </select></td></TR>

    <TR><TD>
	Given the choice, would you take another class from this instructor?
    </TD><TD>
    <select name="o[10]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">YES! Definately</option>
      <OPTION value="4">Probably</option>
      <OPTION value="3">Doesn''t matter</option>
      <OPTION value="2">Probably not</option>
      <OPTION value="1">No!</option>
    </select></td></TR>

    <TR><TD colspan=2><hr width=50%>
	<font size+1><b><u>CLASS</u></b></font>
    </td></tr>

    <TR><TD>
	Were the prerequisites for this class important to do well?
    </TD><TD>
    <select name="o[11]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="2">Not really</option>
      <OPTION value="1">No</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>

    <TR><TD>
	Would you suggest that this class be kept/added as a required class?
    </TD><TD>
    <select name="o[12]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	Rate the room you took the class in.
    </TD><TD>
    <select name="o[13]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>

    <TR><TD colspan=2><hr width=50%>
	<font size+1><b><u>BOOK</u></b></font>
    </td></tr>

    <TR><TD>
	How many textbooks did you have for the class?
    </TD><TD>
    <INPUT TYPE=text name="o[14]" size=2>

    <TR><TD>
	What was the overall quality of your textbook?
    </TD><TD>
    <select name="o[15]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>
    </TABLE>
    </CENTER> 
  <pre>

  </pre>
  <center>
  <font color="#A8A8A8">Overview</font>
  <input type=submit name=menu_choice value="Instructor">
  <input type=submit name=menu_choice value="Work/Tests">
  <input type=submit name=menu_choice value="Class">
  <input type=submit name=menu_choice value="Text">
  <input type=submit name=menu_choice value="Finish">
  </center>~;

    &generic_footer;
}

####################################################################### 
#                             Instructor Form                         #
#######################################################################   

sub instructor_form 
{
    &generic_header("Information on $prof_name");
    print qq~
    <CENTER>
    <IMG SRC="../lines/ruler_li.gif"><br>
    <H1>Information on $prof_name</H1><P>
    <TABLE><TR><TH colspan=2>How well does $prof_name ...</TH></TR>
    <TR><TD>
      Show respect and concern for students?
    </TD><TD>
    <select name="i[1]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">None</option>
    </select></td></TR>

    <TR><TD>
       Encourage student feedback/listen?
    </TD><TD>
    <select name="i[2]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">A lot</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
      Pay attention to what helps you learn?
    </TD><TD>
    <select name="i[3]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">A lot</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	Able to answer the students'' questions?
    </TD><TD>
    <select name="i[4]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">All</option>
      <OPTION value="4">Most</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">A few</option>
      <OPTION value="1">None</option>
    </select></td></TR>

    <TR><TD>
	Provide a good pace for the class?
   </TD><TD>
    <select name="i[5]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Too Fast</option>
      <OPTION value="4">Fast</option>
      <OPTION value="3">Good</option>
      <OPTION value="2">Slow</option>
      <OPTION value="1">Too Slow</option>
    </select></td></TR>

    <TR><TD>
	Flexibile in changing schedule to meet student''s needs?
    </TD><TD>
    <select name="i[6]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
    </select></td></TR>

    <TR><TD>
	Able to make material interesting?
    </TD><TD>
    <select name="i[7]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	Successful in getting you to think?
    </TD><TD>
    <select name="i[8]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	Organized?
    </TD><TD>
    <select name="i[9]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Very</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not Much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	Grade fairly and consistently?
    </TD><TD>
    <select name="i[10]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	Available to students?
    </TD><TD>
    <select name="i[11]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Always</option>
      <OPTION value="4">Usually</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not often</option>
      <OPTION value="1">Never</option>
    </select></td></TR>

    <TR><TD>
	Stay on track/focused class?
    </TD><TD>
    <select name="i[12]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Always</option>
      <OPTION value="4">Usually</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not often</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	Encourage student interactions?
    </TD><TD>
    <select name="i[13]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">A lot</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not often</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	Have appropriate assumptions of your pre-existing knowledge?
    </TD><TD>
    <select name="i[14]">
      <OPTION value="-" Selected></option>
      <OPTION value="1h">No, too high</option>
      <OPTION value="3h">Yes, but high</option>
      <OPTION value="5">Yes</option>
      <OPTION value="3l">Yes, but low</option>
      <OPTION value="1l">No, too low</option>
    </select></td></TR>

    <TR><TD>
	Have appropriate expectations?
    </TD><TD>
    <select name="i[15]">
      <OPTION value="-" Selected></option>
      <OPTION value="1h">No, too high</option>
      <OPTION value="3h">Yes, but high</option>
      <OPTION value="5">Yes</option>
      <OPTION value="3l">Yes, but low</option>
      <OPTION value="1l">No, too low</option>
    </select></td></TR>

    <TR><TD>
	Let you know his/her expectations?
    </TD><TD>
    <select name="i[16]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not really</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	Have clear verbal presentation?
    </TD><TD>
    <select name="i[17]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not really</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	Have clear handwriting?
    </TD><TD>
    <select name="i[18]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not really</option>
      <OPTION value="1">No</option>
    </select></td></TR>
    </TABLE></CENTER>
  <pre>

  </pre>
  <center>
  <input type=submit name=menu_choice value="Overview">
  <font color="#A8A8A8">Instructor</font>
  <input type=submit name=menu_choice value="Work/Tests">
  <input type=submit name=menu_choice value="Class">
  <input type=submit name=menu_choice value="Text">
  <input type=submit name=menu_choice value="Finish">
  </center>~;

    &generic_footer;
}

####################################################################### 
#                      Handouts/Homework/Tests Form                   #
#######################################################################   

sub hw_form 
{
    &generic_header("Handouts, Homework and Tests");

    print qq~
    <CENTER>
    <IMG SRC="../lines/ruler_li.gif"><br>
    <H1>Handouts, Homework and Tests</H1><P>

    <TABLE>
    <TR><TD colspan=2><font size+1><b><u>Handouts</u></b></font>
    </td></tr>
    <TR><TD>
	Were syllabus and schedule available?
    </TD><TD>
    <select name="h[1]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="1">No</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>

    <TR><TD>
	Were they helpful
    </TD><TD>
    <select name="h[2]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="1">No</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>

    <TR><TD>
	What was the overall quality/legibility of handouts?
    </TD><TD>
    <select name="h[3]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
    </select></td></TR>

    <TR><TD>
	How accessible were they?
    </TD><TD>
    <select name="h[4]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Always/on web</option>
      <OPTION value="4">Generally</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not often</option>
      <OPTION value="1">Never</option>
    </select></td></TR>

    <TR><TD colspan=2><hr width=50%>
	<font size+1><b><u>Homework</u></b></font>

    <TR><TD>
	How many assignments were there?
    </TD><TD>
    <INPUT TYPE=text name="h[5]" size=2>
    </td></TR>

    <TR><TD>
	About how much time was spent on them weekly?
    </TD><TD>
    <INPUT TYPE=text name="h[6]" size=4> hours
    </td></TR>

    <TR><TD>
	How relevant were they to lecture?
    </TD><TD>
    <select name="h[7]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Completely</option>
      <OPTION value="4">Mostly</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">A little</option>
      <OPTION value="1">Not much</option>
    </select></td></TR>

    <TR><TD>
	What was the average difficulty level?
    </TD><TD>
    <select name="h[8]">
      <OPTION value="-" Selected></option>
      <OPTION value="1h">Too hard</option>
      <OPTION value="3h">Hard</option>
      <OPTION value="5">Average</option>
      <OPTION value="3e">Easy</option>
      <OPTION value="1e">Too easy</option>
    </select></td></TR>

    <TR><TD>
	What was the percentage of busy to helpful work?
    </TD><TD>
    <select name="h[9]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Completely helpful</option>
      <OPTION value="4">Mostly helpful</option>
      <OPTION value="3">About Equal</option>
      <OPTION value="2">Mostly busy</option>
      <OPTION value="1">Completely busy</option>
    </select></td></TR>

    <TR><TD colspan=2><hr width=50%>
	<font size+1><b><u>Tests</u></b></font>

    <TR><TD>
	How many were there?
    </TD><TD>
    <INPUT TYPE=text NAME="h[10]" SIZE=2>
    </td></TR>

    <TR><TD>
	How relevant were they to lecture?
    </TD><TD>
    <select name="h[11]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Completely</option>
      <OPTION value="4">Generally</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">A little</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	How relevant were they to knowledge of subject matter?
    </TD><TD>
    <select name="h[12]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Completely</option>
      <OPTION value="4">Generally</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	What was the average difficulty level?
    </TD><TD>
    <select name="h[13]">
      <OPTION value="-" Selected></option>
      <OPTION value="1h">Too hard</option>
      <OPTION value="3h">Hard</option>
      <OPTION value="5">Average</option>
      <OPTION value="3e">Easy</option>
      <OPTION value="1e">Too easy</option>
    </select></td></TR>

    <TR><TD>
	What was the average length?
    </TD><TD>
    <select name="h[14]">
      <OPTION value="-" Selected></option>
      <OPTION value="1l">Too long</option>
      <OPTION value="3l">Long</option>
      <OPTION value="5">Average</option>
      <OPTION value="3s">Short</option>
      <OPTION value="1s">Too short</option>
    </select></td></TR>

    <TR><TD>
	What was the level of detail?
    </TD><TD>
    <select name="h[15]">
      <OPTION value="-" Selected></option>
      <OPTION value="1g">Too general</option>
      <OPTION value="3g">General</option>
      <OPTION value="5">Average</option>
      <OPTION value="3s">Specific</option>
      <OPTION value="1s">Too Specific</option>
    </select></td></TR>

    </TABLE></CENTER>
  <pre>

  </pre>
  <center>
  <input type=submit name=menu_choice value="Overview">
  <input type=submit name=menu_choice value="Instructor">
  <font color="#A8A8A8">Work/Tests</font>
  <input type=submit name=menu_choice value="Class">
  <input type=submit name=menu_choice value="Text">
  <input type=submit name=menu_choice value="Finish">
  </center>~;

     &generic_footer;
}

####################################################################### 
#                            Classroom Form                           #
#######################################################################   

sub class_form 
{
    &generic_header("About $class_name");
    print qq~

    <CENTER>
    <IMG SRC="../lines/ruler_li.gif"><br>
    <H1>About $class_name</H1><P>
    <TABLE>
    <TR><TD>
	Why did you take this class?
    </TD><TD>
    <select name="c[1]">
      <OPTION value="-" Selected></option>
      <OPTION value="r">Required</option>
      <OPTION value="e">Elective</option>
      <OPTION value="p">Pre-req</option>
      <OPTION value="f">For Fun</option>
      <OPTION value="o">Other</option>
    </select></td></TR>

    <TR><TD>
	How helpful were the recitation/lab/etc., 
    </TD><TD>
    <select name="c[2]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Very</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3"Average></option>
      <OPTION value="2"Not much></option>
      <OPTION value="1">Not at all</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>

    <TR><TD>
	How practical was this class?
    </TD><TD>
    <select name="c[3]">
      <OPTION value="-" Selected></option>
      <OPTION value="1p">Very practical</option>
      <OPTION value="3p">Practical</option>
      <OPTION value="5">Balanced</option>
      <OPTION value="3t">Theoretical</option>
      <OPTION value="1t">Very theoretical</option>
    </select></td></TR>

    <TR><TD>
	How organized did the class itself seem?
    </TD><TD>
    <select name="c[4]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Very</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	Was this a UNITE (televised) class?
    </TD><TD>
    <select name="c[5]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">yes</option>
      <OPTION value="1">no</option>
      <OPTION value="1">Don''t know</option>
    </select></td></TR>

    <TR><TD>
	Would you recommend this class to another<br>
	(independent of instructor)?
    </TD><TD>
    <select name="c[6]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">YES!</option>
      <OPTION value="4">Probably</option>
      <OPTION value="3">Maybe</option>
      <OPTION value="2">Probably not</option>
      <OPTION value="1">NO!</option>
    </select></td></TR>

    </TABLE></CENTER>
  <pre>

  </pre>
  <center>
  <input type=submit name=menu_choice value="Overview">
  <input type=submit name=menu_choice value="Instructor">
  <input type=submit name=menu_choice value="Work/Tests">
  <font color="#A8A8A8">Class</font>
  <input type=submit name=menu_choice value="Text">
  <input type=submit name=menu_choice value="Finish">
  </center>~;

    &generic_footer;
}

####################################################################### 
#                             Textbook Form                           #
#######################################################################   

#add information on books
sub text_form 
{
    if ($#text_name == 0) {
	&generic_header("About \"$text_name[0]\"");
    }
    else { 
	&generic_header("Textbooks for $class_name");
    }

    print qq~
    <CENTER>
    <IMG SRC="../lines/ruler_li.gif"><br>~;
    $times_thru = 0;
    for ($i=0; $i<$#text_name+1; $i++)
    {
	print qq~
	<H2>Overview of \"$text_name[$i]\"</H2><P>
	<TABLE>

    <TR><TD>
	Was the book truly helpful?
    </TD><TD>~;

    local $x = $i*12+1;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Very</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not much</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	How well written was it?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
    </select></td></TR>

    <TR><TD>
	How correct were the materials and problems?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>

    <TR><TD>
	How substantial was this book
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">All substance</option>
      <OPTION value="4">Mostly substance</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Mostly fluff</option>
      <OPTION value="1">All fluff</option>
    </select></td></TR>

    <TR><TD>
	Rate the clarity of the text
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Very</option>
      <OPTION value="4">Somewhat</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Not very</option>
      <OPTION value="1">Not at all</option>
    </select></td></TR>

    <TR><TD>
	How was the structure and organization?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">Good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
    </select></td></TR>

    <TR><TD>
	Was the speed of the presentation of the materials appropriate?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="1f">No, too fast</option>
      <OPTION value="3f">Yes, but fast</option>
      <OPTION value="5">Yes</option>
      <OPTION value="3s">Yes, but slow</option>
      <OPTION value="1s">No, too slow</option>
    </select></td></TR>

    <TR><TD>
	What was the interest/fun level of it <br>
	    (did you stay awake)?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Great</option>
      <OPTION value="4">good</option>
      <OPTION value="3">Average</option>
      <OPTION value="2">Poor</option>
      <OPTION value="1">Awful</option>
    </select></td></TR>

    <TR><TD>
	Was the cost appropriate?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="1">Way too much</option>
      <OPTION value="2">Too much</option>
      <OPTION value="3">A lot, but worth it</option>
      <OPTION value="4">Fine</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>

    <TR><TD>
	Was it available when you needed to buy it?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="1">No</option>
      <OPTION value="N">Not Applicable</option>
    </select></td></TR>

    <TR><TD>
	Do you plan on keeping this book?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">Yes</option>
      <OPTION value="1">No</option>
    </select></td></TR>

    <TR><TD>
	Would you recommend this book to another?
    </TD><TD>~;
    $x++;
    print qq~
    <select name="t[$x]">
      <OPTION value="-" Selected></option>
      <OPTION value="5">YES!</option>
      <OPTION value="4">Probably</option>
      <OPTION value="3">Maybe</option>
      <OPTION value="2">Probably not</option>
      <OPTION value="1">NO!</option>
    </select></td></TR>
    </TABLE>
    <HR WIDTH=50% SIZE=3>~;    
    }

    print qq~
    </CENTER> 
  <pre>

  </pre>
  <center>
  <input type=submit name=menu_choice value="Overview">
  <input type=submit name=menu_choice value="Instructor">
  <input type=submit name=menu_choice value="Work/Tests">
  <input type=submit name=menu_choice value="Class">
  <font color="#A8A8A8">Text</font>
  <input type=submit name=menu_choice value="Finish">
  </center>~;
    &generic_footer;
}

####################################################################### 
#                                 Final Form                          #
#######################################################################   

sub end_form 
{
    &generic_header("Submit the Grade");
    $calc_total_grade = &calculate_overall_grade;
    $calc_prof_grade = &calculate_prof_grade;
#    $calc_total_grade = "A-";
#    $calc_prof_grade = "C+";

    print qq~

    <CENTER>
    <IMG SRC="../lines/ruler_li.gif"><br>
    <H1>Submit the Grade</H1><P>
    <INPUT TYPE="hidden" NAME="calc_total_grade" VALUE="$calc_total_grade">
    <INPUT TYPE="hidden" NAME="calc_prof_grade" VALUE="$calc_prof_grade">

    <pre>

    </pre>
    <b>NOTE:</b><br>
    The information added here will not be sent until you press
    the "SEND" button at the bottom of this page.
    <p><hr width=75%><p>
    The calculated grade for your professor is
    <INPUT TYPE=text NAME="f[1]" Value="$calc_prof_grade" size=2> 
    <i>(Please change it if it is incorrect).</i>
    <p>
    The calculated overall grade for the class itself is 
    <INPUT TYPE=text NAME="f[2]" Value="$calc_total_grade" size=2> 
    <i>(Please change it if it is incorrect).</i>
    <pre>

    </pre>
    In addition, please add any comments below on ways to improve this
    instructor evaluation process. Any comments you make will go solely to
    the developers of this program, <blink>NOT</blink> to the instructor.
    <TEXTAREA ROWS=6 COLS=70 wrap=physical NAME="f[3]">
Compliments:

Complaints:

Comments:
    </TEXTAREA>
    <center><INPUT TYPE=submit NAME="menu_choice" VALUE="Submit Data">
    </center>~;

    &generic_footer;
}

####################################################################### 
#                 Database Connectivity Subroutine                    #
#######################################################################   
    #
    # This function is used to get the name of the professor, the 
    # classroom, and the book titles and publishers from the database
    # based upon the class submitted.  It mostly involves database 
    # calls and modification of data.
    #
sub get_db_data
{
    #
# this stuff will be gotten from the database
$prof_name = "Joe Schmoe";
$prof_pic_name = "bamshad2.jpg";
@text_name = ("This is the text", "and another");
$class_name = "CSci 4-205";


}

####################################################################### 
#                         Submit It Subroutine                        #
#######################################################################   

sub submit_it
{
    #this will contain the calls to send the information to the database,
    # it will check for duplicate entries and update, or add new
    # based on the school, it may check grades, and separate it immediately
    #
    # NOTE: Info from the final form will be put into a separate db for the
    # maintainers (us).  A new script should be given that mails it to us
    # after the first quarter, or so.
    #
    # it will also have to push a page forth that thanks them

  print qq~
  <HTML>
  <HEAD>
  <TITLE>Thanks for your submission</TITLE>
  </HEAD>
  <BODY BACKGROUND="mnbackgrn.gif" TEXT = "#000000">
  Thanks for your submission.  Your data will be added to the database 
  at the end of the term.  Any information you submitted can be changed
  until that point.  However, at the start of the next term, the data will
  be unchangeable.
  <P>

  Please send email to <a href="mailto:$support_email">$support_email</a> 
  with any problems, corrections or questions you may have.
  <P>

  </BODY></HTML>~;
}


####################################################################### 
#                             Generic Header                          #
#######################################################################   

sub generic_header
{
  local ($title) = @_;
  print qq~
  <HTML>
  <HEAD>
  <TITLE>$title</TITLE>
  </HEAD>
  <BODY BACKGROUND="mnbackgrn.gif" TEXT = "#000000">
  <FORM METHOD="post" ACTION="Form.cgi">
  <INPUT TYPE="hidden" NAME="class_name" VALUE="$class_name">
  <INPUT TYPE="hidden" NAME="id_no" VALUE="$id_no">
  <INPUT TYPE="hidden" NAME="prof_name" VALUE="$prof_name">
  <INPUT TYPE="hidden" NAME="text_name" VALUE="@text_name">
  <INPUT TYPE="hidden" NAME="curr_choice" VALUE="$menu_choice">~;

  foreach $key (sort keys %Done_Data)
  {
      print qq~
<INPUT TYPE="hidden" NAME="$key" VALUE="$Done_Data{$key}">\n~;
  }
}

####################################################################### 
#                             Generic Footer                          #
#######################################################################   

sub generic_footer
  {
  print qq~
  </FORM>
  </BODY>
  </HTML>~;
  }

####################################################################### 
#                                  Fix Data                           #
#######################################################################   
           #
           # The purpose of this is to check hidden data needed on 
           # every form and to turn it into the correct format.


sub fix_data
{
    if ($form_data{'class_name'} eq "") {       #create format for classname
	if ($form_data{'ext'} ne "") {
	    $class_name="$form_data{'dept'} $form_data{'class_no'}-Ext";
	}
	else {
	    $class_name= "$form_data{'dept'} $form_data{'class_no'}";
	}
    }
    else {
	$class_name = $form_data{'class_name'};
    }
    $id_no = $form_data{'id_no'};    #comes from front-end

    if ($prof_name eq "") {
	$prof_name = $form_data{'prof_name'};
    }
    if (@text_name eq "") {
	@text_name = $form_data{'text_name'};
    }
    if ($curr_choice eq "") {
	$curr_choice = $form_data{'curr_choice'};
    }

    for ($i=0; $i<$#Fsections; $i++)
    {
	local $fs = $Fsections[$i];

	if ($form_data{$fs} ne "") {
	    $Done_Data{$fs} = $form_data{$fs};
	}
    }
           #
           # Now, convert the data that was given and attach it to the 
           # forms... each form that's filled out will be carried over
           # to the others, and eventually all will be submitted.
           #
           # NOTE: Any change in the number of questions will affect this
           #
    if ($curr_choice ne "")
    {
	if ($curr_choice eq "Overview") {
	    for ($j = 1; $j<=15; $j++) {
		$x = "o[$j]";
		$y = $form_data{$x};
		if ($y eq "")
		{ $y = "-"; }
		push @temp_data, $y;
	    }
	}
	elsif ($curr_choice eq "Instructor") {
	    for ($j = 1; $j<=18; $j++) {
		$x = "i[$j]";
		$y = $form_data{$x};
		if ($y eq "")
		{ $y = "-"; }
		push @temp_data, $y;
	    }
	}
	elsif ($curr_choice eq "Work/Tests") {
	    for ($j = 1; $j<=15; $j++) {
		$x = "h[$j]";
		$y = $form_data{$x};
		if ($y eq "")
		{ $y = "-"; }
		push @temp_data, $y;
	    }
	}
	elsif ($curr_choice eq "Class") {
	    for ($j = 1; $j<=6; $j++) {
		$x = "c[$j]";
		$y = $form_data{$x};
		if ($y eq "")
		{ $y = "-"; }
		push @temp_data, $y;
	    }
	}
	elsif ($curr_choice eq "Text") {
	    for ($j = 1; $j<=(12 * ($#text_name + 1)); $j++) {
		$x = "t[$j]";
		$y = $form_data{$x};
		if ($y eq "")
		{ $y = "-"; }
		push @temp_data, $y;
	    }
	}
	elsif ($curr_choice eq "Final") {
	    for ($j = 1; $j<=3; $j++) {
		$x = "f[$j]";
		$y = $form_data{$x};
		if ($y eq "")
		{ $y = "-"; }
		push @temp_data, $y;
	    }
	}
	else           #final area, data sent.
	{
	}
	$summary = join(' ', @temp_data);
	@temp_data = ();
	$Done_Data{$curr_choice} = $summary;
	
    }
}

####################################################################### 
#                    Calculate Grade for the Professor                #
#######################################################################   
       #
       # Due to the fact that many questions may go unanswered, the
       # instructor's grade is based upon questions only found in the 
       # overview.  All questions are currently given even weight, but 
       # as a trend is found, they may be adjusted
       #
sub calculate_prof_grade
{
    @queues = split(' ', $form_data{'Overview'});
    local @pert_queues = ($queues[7], $queues[8], $queues[9]);
    local $total = 0;
    local $num_answered = 0;

    foreach $pert_queue (@pert_queues)
    {
	if ( $pert_queue =~ /\d/ ) {
	    $total += $pert_queue;                #give equal weight
	    $num_answered++;
	}
    }

    $total /= $num_answered;                   #divide by # answered

    if ($total > 4.95) {
	$calc_prof_grade = "A+"; }
    elsif ($total > 4.6) {
	$calc_prof_grade = "A"; }
    elsif ($total > 4.3) {
	$calc_prof_grade = "A-"; }
    elsif ($total > 4.0) {
	$calc_prof_grade = "B+"; }
    elsif ($total > 3.6) {
	$calc_prof_grade = "B"; }
    elsif ($total > 3.3) {
	$calc_prof_grade = "B-"; }
    elsif ($total > 3.0) {
	$calc_prof_grade = "C+"; }
    elsif ($total > 2.6) {
	$calc_prof_grade = "C"; }
    elsif ($total > 2.3) {
	$calc_prof_grade = "C-"; }
    elsif ($total > 2.0) {
	$calc_prof_grade = "D+"; }
    elsif ($total > 1.6) {
	$calc_prof_grade = "D"; }
    elsif ($total > 1.3) {
	$calc_prof_grade = "D-"; }
    else {
	$calc_prof_grade = "F"; }
    return ($calc_prof_grade);
}

####################################################################### 
#                        Calculate Overall Grade                      #
#######################################################################   
       #
       # Due to the fact that many questions may go unanswered, the
       # overall  grade is based upon questions only found in the 
       # overview.  All questions are currently given even weight, but 
       # as a trend is found, they may be adjusted
       #
sub calculate_overall_grade
{
    @queues = split(' ', $form_data{'Overview'});
    local @pert_queues = ($queues[2], $queues[3], $queues[4],$queues[5], 
		    $queues[7], $queues[8],$queues[9], $queues[12], 
		    $queues[14]);
    local $total = 0;
    local $num_answered = 0;
    foreach $pert_queue (@pert_queues)
    {
	if ( $pert_queue =~ /\d/ ) {
	    $total += $pert_queue;                #give equal weight
	    $num_answered++;
	}
    }
    $total /= $num_answered;                   #divide by # answered
    if ($total > 4.95) {
	$calc_total_grade = "A+"; }
    elsif ($total > 4.6) {
	$calc_total_grade = "A"; }
    elsif ($total > 4.3) {
	$calc_total_grade = "A-"; }
    elsif ($total > 4.0) {
	$calc_total_grade = "B+"; }
    elsif ($total > 3.6) {
	$calc_total_grade = "B"; }
    elsif ($total > 3.3) {
	$calc_total_grade = "B-"; }
    elsif ($total > 3.0) {
	$calc_total_grade = "C+"; }
    elsif ($total > 2.6) {
	$calc_total_grade = "C"; }
    elsif ($total > 2.3) {
	$calc_total_grade = "C-"; }
    elsif ($total > 2.0) {
	$calc_total_grade = "D+"; }
    elsif ($total > 1.6) {
	$calc_total_grade = "D"; }
    elsif ($total > 1.3) {
	$calc_total_grade = "D-"; }
    else {
	$calc_total_grade = "F"; }
    return $calc_total_grade;
}

####################################################################### 
#                       Require Supporting Libraries.                 #
#######################################################################   
                
                # require_supporting_libraries is used to read in some of
                # the supporting files that this script will take
                # advantage of. 
                #
                # require_supporting_libraries takes a list of arguments
                # beginning with the current filename, the current line
                # number and continuing with the list of files which must
                # be required using the following syntax:
                # 
                # &require_supporting_libraries (__FILE__, __LINE__,    
                #                               "file1", "file2",
                #                               "file3"...);
                #
                # Note: __FILE__ and __LINE__ are special Perl variables
                # which contain the current filename and line number   
                # respectively.  We'll continually use these two variables
                # throughout the rest of this script in order to generate
                # useful error messages.
                
sub require_supporting_libraries
  {
                
                # The incoming file and line arguments are split into  
                # the local variables $file and $line while the file list
                # is assigned to the local list array @require_files.
                # 
                # $require_file which will just be a temporary holder   
                # variable for our foreach processing is also defined as a
                # local variable.
                 
  local ($file, $line, @require_files) = @_;
  local ($require_file);
                
                # Next, the script checks to see if every file in the
                # @require_files list array exists (-e) and is readable by
                # it (-r). If so, the script goes ahead and requires it.

  foreach $require_file (@require_files)
    {           
    if (-e "$require_file" && -r "$require_file")
      {
      require "$require_file";
      }
                
                # If not, the scripts sends back an error message that
                # will help the admin isolate the problem with the script.
                 
    else
      {
      print "Content-type: text/html\n\n";
      print "I am sorry but I was unable to require $require_file at line
            $line in $file.  Would you please make sure that you have the 
            path correct and that the permissions are set so that I have
            read access?  Thank you.";
      exit;
      }         
    } # End of foreach $require_file (@require_files)
  } # End of sub require_supporting_libraries


#################################################################
#                      get_date Subroutine                      #
#################################################################
 
                # get_date is used to get the current date and time and
                # format it into a readable form.  The subroutine takes no
                # arguments and is called with the following syntax:
                #
                # $date = &get_date;
                #
                # It will return the value of the current date, so you 
                # must assign it to a variable in the calling routine if
                # you are going to use the value.

sub get_date
  {

                # The subroutine begins by defining some local working  
                # variables
                
  local ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$date);   
  local (@days, @months);

  @days = ('Sunday','Monday','Tuesday','Wednesday','Thursday',
           'Friday','Saturday');
  @months = ('January','February','March','April','May','June','July', 
             'August','September','October','November','December');

                # Next, it uses the localtime command to get the current
                # time, from the value returned by the time
                # command, splitting it into variables.
                
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  
                # Then the script formats the variables and assign them to
                # the final $date variable.  Note that $sc_current_century
                # is defined in web_store.setup.  Since the 20th centruy
                # is really 1900-1999, we'll need to subtract 1 from this
                # value in order to format the year correctly.
                
  if ($hour < 10)
    {
    $hour = "0$hour";
    }
  if ($min < 10) 
    {
    $min = "0$min";
    }
  if ($sec < 10)
    { $sec = "0$sec";
    }
  $mon++;
  $year = ($current_century-1) . "$year";
  $date = "$mon/$mday/$year at $hour\:$min\:$sec";
  return $date;
  }             
