#!/usr/local/bin/perl

# Name: Form.cgi
#
# Version: 1.0
# Last Modified: 8/25/97
#
# Purpose: Creates forms for students to be able to evaluate their
# instructors
#

$| = 1;             #flush the buffer
print "Content-type: text/html\n\n";

&require_supporting_libraries (__FILE__, __LINE__,
			       "./Library/cgi-lib.pl");
&ReadParse(*form_data);
#&GetInfo();            #subroutine to get basic info on classes

###################################################################
#                           Local Variables                       #
###################################################################

$start_url = "http://www.cs.umn.edu/\~doyle/8110";
if ($form_data{'menu_choice'} ne "") {
    $menu_choice = $form_data{'menu_choice'};
}
else
{
    $menu_choice = "overview";
}
###################################################################

# check for missing infromation
if (($form_data{'class_no'} eq "") || ($form_data{'id_no'} eq ""))
{
    &generic_header("Error: Missing Data");
    print qq~
    <meta http-equiv="refresh" content="5; url=$start_url">


    Please fill in your class number and school ID before continuing.<p>~;
    if   ($form_data{'id_no'} eq "")
    {
	print "This information is completely anonymous, your ID # is \
required by this program for statistical purposes only.  Your information \
will NEVER be released to the instructor or administration.<p>\n";
    }
    &generic_footer;
    exit;
}

#menu choices, which form to load
elsif ($menu_choice eq "overview") { 
    if ($form_data{'ext'} ne "") {
     $class_name="$form_data{'dept'} $form_data{'class_no'}-Ext";
    }
    else {
	$class_name= "$form_data{'dept'} $form_data{'class_no'}";
    }
    &overview_form; }
elsif ($menu_choice eq "instructor") {
    &instructor_form; }
elsif ($menu_choice eq "hw") {
    &hw_form; }
elsif ($menu_choice eq "class") {
    &class_form; }
elsif ($menu_choice eq "text") {
    &text_form; }
elsif ($menu_choice eq "end") {
    &end_form; }
else
{
    print "Eeeek, you shouldn't be able to see this!!!";
}
&generic_footer;


####################################################################### 
#                               Overview Form                         #
#######################################################################   

#this will accomplish 2 things
# 1) goes out and grabs information from the database
# 2) pushes forth a form to fill out.  Should get info behind scenes
# but will need to use temp files -- ugh!
sub overview_form 
{
    &generic_header("Overview of $class_name");
    print qq~
    <INPUT TYPE="hidden" NAME="class_name" VALUE="$class_name">
    <INPUT TYPE="hidden" NAME="id_no" VALUE="$id_no">

    <CENTER>
    <IMG SRC="../lines/ruler_li.gif"><br>
    <H1>Overview of $class_name</H1><P>
    <TABLE>
    <TR><TD colspan=6><font size+1><b>SELF</b></font></td></tr>
    <TR><TD>
    What was your ability in the subject before the class?
    </TD><TD>
    <select name="o1">
    <INPUT type=radio name="o1" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o1" value="2"></td><td>
    <INPUT type=radio name="o1" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o1" value="4"></td><td>
    <INPUT type=radio name="o1" value="5"></td></TR>
    <TR><TD>
    What was your ability in subject after the course?
    </TD><TD>
    <select name="o2">
    <INPUT type=radio name="o2" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o2" value="2"></td><td>
    <INPUT type=radio name="o2" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o2" value="4"></td><td>
    <INPUT type=radio name="o2" value="5"></td></TR>
    <TR><TD>
    How motivated were you to learn?
    </TD><TD>
    <select name="o3">
    <INPUT type=radio name="o3" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o3" value="2"></td><td>
    <INPUT type=radio name="o3" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o3" value="4"></td><td>
    <INPUT type=radio name="o3" value="5"></td></TR>
    <TR><TD>
    How much did you learn?
    </TD><TD>
    <select name="o4">
    <INPUT type=radio name="o4" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o4" value="2"></td><td>
    <INPUT type=radio name="o4" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o4" value="4"></td><td>
    <INPUT type=radio name="o4" value="5"></td></TR>
    <TR><TD>
    Do you feel you learned as much as you could have?
    </TD><TD>
    <select name="o5">
    <INPUT type=radio name="o5" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o5" value="2"></td><td>
    <INPUT type=radio name="o5" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o5" value="4"></td><td>
    <INPUT type=radio name="o5" value="5"></td></TR>
    <TR><TD>
    How much did you enjoy the class?
    </TD><TD>
    <select name="o6">
    <INPUT type=radio name="o6" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o6" value="2"></td><td>
    <INPUT type=radio name="o6" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o6" value="4"></td><td>
    <INPUT type=radio name="o6" value="5"></td></TR>
    <TR><TD>
    How much time did you spend on it per week?
    </TD><TD>
    <select name="o7">
    <INPUT type=radio name="o7" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o7" value="2"></td><td>
    <INPUT type=radio name="o7" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o7" value="4"></td><td>
    <INPUT type=radio name="o7" value="5"></td></TR>


    <TR><TD colspan=6><font size+1><b>INSTRUCTOR</b></font></td></tr>

    <TR><TD>
    Rate the instructor''s overall teaching ability
    </TD><TD>
    <select name="o8">
    <INPUT type=radio name="o8" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o8" value="2"></td><td>
    <INPUT type=radio name="o8" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o8" value="4"></td><td>
    <INPUT type=radio name="o8" value="5"></td></TR>
    <TR><TD>
    Rate their knowledge of the subject matter
    </TD><TD>
    <select name="o9">
    <INPUT type=radio name="o9" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o9" value="2"></td><td>
    <INPUT type=radio name="o9" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o9" value="4"></td><td>
    <INPUT type=radio name="o9" value="5"></td></TR>
    <TR><TD>
    Given the choice, would you take another class from this instructor?
    </TD><TD>
    <select name="o10">
    <INPUT type=radio name="o10" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o10" value="2"></td><td>
    <INPUT type=radio name="o10" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o10" value="4"></td><td>
    <INPUT type=radio name="o10" value="5"></td></TR>

    <TR><TD colspan=6><font size+1><b>CLASS</b></font></td></tr>

    <TR><TD>
    Were the prerequisites for this class important to do well?
    </TD><TD>
    <select name="o11">
    <INPUT type=radio name="o11" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o11" value="2"></td><td>
    <INPUT type=radio name="o11" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o11" value="4"></td><td>
    <INPUT type=radio name="o11" value="5"></td></TR>
    <TR><TD>
    Would you suggest that this class be kept/added as a required class?
    </TD><TD>
    <select name="o12">
    <INPUT type=radio name="o12" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o12" value="2"></td><td>
    <INPUT type=radio name="o12" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o12" value="4"></td><td>
    <INPUT type=radio name="o12" value="5"></td></TR>
    <TR><TD>
    Rate the room you took the class in.
    </TD><TD>
    <select name="o13">
    <INPUT type=radio name="o13" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o13" value="2"></td><td>
    <INPUT type=radio name="o13" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o13" value="4"></td><td>
    <INPUT type=radio name="o13" value="5"></td></TR>

    <TR><TD colspan=6><font size+1><b>BOOK</b></font></td></tr>

    <TR><TD>
    What was the overall quality of your textbook?
    </TD><TD>
    <select name="o14">
    <INPUT type=radio name="o14" value="1"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o14" value="2"></td><td>
    <INPUT type=radio name="o14" value="3"></td><td bgcolor="#c9f0c9">
    <INPUT type=radio name="o14" value="4"></td><td>
    <INPUT type=radio name="o14" value="5"></td></TR>
    </TABLE>
    </CENTER>~;

    &generic_footer;
}

####################################################################### 
#                             Instructor Form                         #
#######################################################################   

#add instructor's name when get a chance
sub instructor_form 
{
    &generic_header("Information on Instructor's Name");
    &generic_footer;
}
####################################################################### 
#                      Handouts/Homework/Tests Form                   #
#######################################################################   

sub hw_form 
{
    &generic_header("Handouts, Homework and Tests");
    &generic_footer;
}
####################################################################### 
#                            Classroom Form                           #
#######################################################################   

#add information on building and room
sub class_form 
{
    &generic_header("About Building and Room");
    &generic_footer;
}

####################################################################### 
#                             Textbook Form                           #
#######################################################################   

#add information on books
sub text_form 
{
#    if (no_of_texts == 1)
#    {
#	&generic_header("About Textbook name");
#    }
#    else
#    { #add loop for # of books
	&generic_header("Textbooks for $form_data{'dept'} $form_data{'class_no'}");
#    }
    &generic_footer;
}

####################################################################### 
#                                 End Form                            #
#######################################################################   

sub end_form 
{
    &generic_header("Submit the Grade");
    &generic_footer;
}
####################################################################### 
#                             Generic Header                          #
#######################################################################   

sub generic_header
  {
  local ($title) = @_;
  print qq~
  <HTML>
  <HEAD>
  <TITLE>$title</TITLE>
  </HEAD>
  <BODY BGCOLOR = "#FFFFFF" TEXT = "#000000">
  <FORM METHOD="post" ACTION="Form.cgi">~;
  }

####################################################################### 
#                             Generic Footer                          #
#######################################################################   

sub generic_footer
  {
  print qq~
  </FORM>
  </BODY>
  </HTML>~;
  }


####################################################################### 
#                       Require Supporting Libraries.                 #
#######################################################################   
                
                # require_supporting_libraries is used to read in some of
                # the supporting files that this script will take
                # advantage of. 
                #
                # require_supporting_libraries takes a list of arguments
                # beginning with the current filename, the current line
                # number and continuing with the list of files which must
                # be required using the following syntax:
                # 
                # &require_supporting_libraries (__FILE__, __LINE__,    
                #                               "file1", "file2",
                #                               "file3"...);
                #
                # Note: __FILE__ and __LINE__ are special Perl variables
                # which contain the current filename and line number   
                # respectively.  We'll continually use these two variables
                # throughout the rest of this script in order to generate
                # useful error messages.
                
sub require_supporting_libraries
  {
                
                # The incoming file and line arguments are split into  
                # the local variables $file and $line while the file list
                # is assigned to the local list array @require_files.
                # 
                # $require_file which will just be a temporary holder   
                # variable for our foreach processing is also defined as a
                # local variable.
                 
  local ($file, $line, @require_files) = @_;
  local ($require_file);
                
                # Next, the script checks to see if every file in the
                # @require_files list array exists (-e) and is readable by
                # it (-r). If so, the script goes ahead and requires it.

  foreach $require_file (@require_files)
    {           
    if (-e "$require_file" && -r "$require_file")
      {
      require "$require_file";
      }
                
                # If not, the scripts sends back an error message that
                # will help the admin isolate the problem with the script.
                 
    else
      {
      print "Content-type: text/html\n\n";
      print "I am sorry but I was unable to require $require_file at line
            $line in $file.  Would you please make sure that you have the 
            path correct and that the permissions are set so that I have
            read access?  Thank you.";
      exit;
      }         
    } # End of foreach $require_file (@require_files)
  } # End of sub require_supporting_libraries


#################################################################
#                      get_date Subroutine                      #
#################################################################
 
                # get_date is used to get the current date and time and
                # format it into a readable form.  The subroutine takes no
                # arguments and is called with the following syntax:
                #
                # $date = &get_date;
                #
                # It will return the value of the current date, so you 
                # must assign it to a variable in the calling routine if
                # you are going to use the value.

sub get_date
  {

                # The subroutine begins by defining some local working  
                # variables
                
  local ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$date);   
  local (@days, @months);

  @days = ('Sunday','Monday','Tuesday','Wednesday','Thursday',
           'Friday','Saturday');
  @months = ('January','February','March','April','May','June','July', 
             'August','September','October','November','December');

                # Next, it uses the localtime command to get the current
                # time, from the value returned by the time
                # command, splitting it into variables.
                
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  
                # Then the script formats the variables and assign them to
                # the final $date variable.  Note that $sc_current_century
                # is defined in web_store.setup.  Since the 20th centruy
                # is really 1900-1999, we'll need to subtract 1 from this
                # value in order to format the year correctly.
                
  if ($hour < 10)
    {
    $hour = "0$hour";
    }
  if ($min < 10) 
    {
    $min = "0$min";
    }
  if ($sec < 10)
    { $sec = "0$sec";
    }
  $mon++;
  $year = ($current_century-1) . "$year";
  $date = "$mon/$mday/$year at $hour\:$min\:$sec";
  return $date;
  }             
