import java.awt.*;
import java.awt.image.ImageObserver;
import java.net.*;
import java.applet.*;


public class Rater extends Applet {

  public ProfCanvas prof;
  public MediaTracker tracker;
  public Panel goodpanel, badpanel, emptypanel, btnpanel, goodbad, finalpanel;
  public GridBagLayout gridbag = new GridBagLayout();
  public CardLayout cardlayout = new CardLayout();

  public Checkbox sound;
  public Checkbox[] goodboxes;
  public Checkbox[] badboxes;
  Color panelcolor = new Color(0x00ffff);
  Font f = new Font("Helvetica", Font.BOLD,14);

  int currx = 0, curry = 0;
  int score=0;
  boolean nosound = false;                                  //default: sound on

  String HelpText;

  URL url;
   
  public void init() 
    {
      System.err.println("code #5");
                                                     //get image of professor
      String targetImage = this.getParameter("Instructor");
      if (targetImage == null) {
	System.err.println("Invalid image object!");
	targetImage="generic.gif";
      }
      tracker = new MediaTracker(this);
      Image image = getImage(getCodeBase(), targetImage);
      tracker.addImage(image,0);

      Image Star = getImage(getCodeBase(), "star.gif");
      tracker.addImage(Star,1);
      Image Splat = getImage(getCodeBase(), "splat-s.gif");
      tracker.addImage(Splat,2);
      try { tracker.waitForAll(); }
      catch (InterruptedException e)
	{ System.err.println("Error in loading image" + e); }

                                               //put professor image into canvas
      int imageWidth = image.getWidth(this);
      int imageHeight = image.getHeight(this);
      prof = new ProfCanvas(image, this, imageWidth, imageHeight);
      prof.Star = Star;
      prof.Splat = Splat;
     
                                                //find page to load to afterward
      try 
	{
	  url = new URL(this.getParameter("GoHereAfter"));
	}
      catch (MalformedURLException e)
	{
	  url = getCodeBase();
	}
                                                                 //load images
      setBackground(Color.white);


      
	                                        //put buttons into their own panel
      btnpanel = new Panel();
      btnpanel.setLayout(gridbag);
      add("South",btnpanel);
      constrain(btnpanel,new Button("Rotten Fruit"), 0,0,1,1);
      constrain(btnpanel,new Button("Gold Star"), 1,0,1,1);
      constrain(btnpanel,new Button("Done"), 2,0,1,1);
      sound = new Checkbox("Sound off");
      constrain(btnpanel, sound, 3,0,1,1);
      Data();                                                //put info into arrays


      goodpanel = new Panel();                               //make the panel of good traits
      goodpanel.setLayout(gridbag);
      add("East",goodpanel);
      goodpanel.setBackground(panelcolor);

      Label gd = new Label("Specific GOOD Traits",Label.CENTER);
      gd.setFont(f);
      constrain(goodpanel, gd, 0,0,3,1);
	 
      for (int i=0; i<10; i++)
	  constrain(goodpanel, goodboxes[i],0,i+2,3,1);


      badpanel = new Panel();                               //make the panel of bad traits
      badpanel.setLayout(gridbag);
      add("East",badpanel);
      badpanel.setBackground(panelcolor);

      Label bd = new Label("Specific BAD Traits",Label.CENTER);
      bd.setFont(f);
      constrain(badpanel, bd, 0,0,3,1);
	 
      for (int i=0; i<10; i++)
	  constrain(badpanel, badboxes[i],0,i+2,3,1);

      emptypanel = new Panel();

      goodbad = new Panel();                               //set up the changeable panel
      goodbad.setLayout(cardlayout);
      add("North",goodbad);
      goodbad.add("Empty", emptypanel);
      goodbad.add("Bad Stuff",badpanel);
      goodbad.add("Good Stuff",goodpanel);


      finalpanel = new Panel();                       //set up the panel containing everything                                       
      finalpanel.setLayout(gridbag);
      add("North",finalpanel);
            finalpanel.setBackground(Color.white);
      constrain(finalpanel, prof,0,0,1,1);
      constrain(finalpanel, btnpanel, 0,1,1,1);
      constrain(finalpanel, goodbad, 1,0,1,1);
      help();
    }

  public void help()                      // ways to make sure student knows what's going on
    {
      if (prof.ImgChoice == null)
	HelpText = "Click on the button that describes what you'd like to give your instructor";

      else if (prof.ImgChoice !=null && prof.score == 0)
	HelpText = "Now, click on the picture of the instructor";
      else
	HelpText = "Keep on clicking! Press 'Done' to submit the information";
      repaint();
    }


  public boolean action(Event e, Object arg)              //check if a button was pressed & which one
    {
      if(e.target instanceof Button)
        {
	  String btnChoice = (String)arg;
	  if (btnChoice.equals("Rotten Fruit"))         //choose bad image and bad panel
	    {
	      prof.ImgChoice = prof.Splat;   
	      ((CardLayout)goodbad.getLayout()).show(goodbad,"Bad Stuff");
	    }
	  else if (btnChoice.equals("Gold Star"))       //choose good image and panel
	    {
	      prof.ImgChoice = prof.Star;
	      ((CardLayout)goodbad.getLayout()).show(goodbad,"Good Stuff");
	    }
	  else if(btnChoice.equals("Done"))            //clear things up and go to new page
	    {
	      ((CardLayout)goodbad.getLayout()).show(goodbad,"Empty");
	      prof.ImgChoice = null;	      
	      this.getAppletContext().showDocument(url, "_top");
	      prof.destroy();
	      gridbag.removeLayoutComponent(badpanel);
	      gridbag.removeLayoutComponent(goodpanel);
	      gridbag.removeLayoutComponent(emptypanel);
	    }
	  else
	    {
	      System.err.println("Unexplained button pressed");
	      return false;
	    }
	    
	  return true;
        }
      else if(e.target instanceof Checkbox)
	{
	  nosound = sound.getState();
	  return true;
	}

      else return false;
    }
  
  
  public void update(Graphics g)
    {
      paint(g); 
    }
  
  public boolean mouseDown(Event evt, int x, int y)  //mouse down, but not on button
    {
      help();
      while (prof.score < score) {
	if (nosound == false)
	  play(getCodeBase(), "splat.au");
	score--;
      }
      while (prof.score > score) {
	      if (nosound == false)
		play(getCodeBase(), "ding.au");
	      score++;	
      }
      return true;
    }

  public void paint(Graphics g) 
    {
      g.setFont(f);
      g.drawString(HelpText, 0, 425);
      finalpanel.paintComponents(g);
    }
  
  // contrain for labels
  public void constrain(Container container, Component component, int grid_x, 
			int grid_y, int grid_width, int grid_height)
    {
      constrain(container, component, grid_x, grid_y, grid_width, grid_height,
		GridBagConstraints.NONE, GridBagConstraints.WEST, 
		0.0, 0.0, 0, 20, 0, 0);
    }

  public void constrain(Container container, Component component, 
			int grid_x, int grid_y, int grid_width, 
			int grid_height, int fill, int anchor, 
			double weight_x, double weight_y, int top, int left,
			int bottom, int right)
    {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x; c.gridy=grid_y;
      c.gridwidth = grid_width; c.gridheight = grid_height;
      c.fill = fill; c.anchor = anchor;
      c.weightx = weight_x; c.weighty = weight_y;
      if (top+bottom+left+right>0)
	c.insets = new Insets(top,left,bottom,right);

      ((GridBagLayout)container.getLayout()).setConstraints(component,c);
      container.add(component);
    }


  public void Data()                             //move data here, out of the way
    {
      goodboxes = new Checkbox[10];
      goodboxes[0] = new Checkbox("exciting");
      goodboxes[1] = new Checkbox("helpful");
      goodboxes[2] = new Checkbox("knoledgeable");
      goodboxes[3] = new Checkbox("goes out of the way");
      goodboxes[4] = new Checkbox("fun");
      goodboxes[5] = new Checkbox("makes class interesting");
      goodboxes[6] = new Checkbox("always available");
      goodboxes[7] = new Checkbox("respects students");
      goodboxes[8] = new Checkbox("organized");
      goodboxes[9] = new Checkbox("concerned");
      
      badboxes = new Checkbox[10];
      badboxes[0] = new Checkbox("could care less");
      badboxes[1] = new Checkbox("mumbles");
      badboxes[2] = new Checkbox("boring");
      badboxes[3] = new Checkbox("talks to board/self");
      badboxes[4] = new Checkbox("unavailable");
      badboxes[5] = new Checkbox("disrespectful");
      badboxes[6] = new Checkbox("disorganized");
      badboxes[7] = new Checkbox("thick accent");
      badboxes[8] = new Checkbox("immoble");
      badboxes[9] = new Checkbox("unfair");
    }
}


