import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import Tab;
import Form1;



class ImageCanvas extends Canvas            //the tabs

{  
  public int X, Y;
  final int FONTSIZE = 14; //size of font to indicate spacing
  final String FONTTYPE = "TimesRoman";
  public Font theFont = new Font(FONTTYPE, Font.BOLD, FONTSIZE);

  int ImgW=100, ImgH=30;			//size of tabs


  /* Note:  Tabs start at 0 and extend the distance of the 7th tab (6 full ones)*/
  
  //  public Tab Start[] = new Tab[3];
  public Tab Input[] = new Tab[6];

  Container parent;
  Dimension minSize;

  int session, choice1, choice2;		// menu (tab) options


  public ImageCanvas(Container mom, int session, int choice1) 
    {

      /*      Start[0] = new Tab(0,0,ImgW,ImgH,"Input");		//start tabs
      Start[1] = new Tab(ImgW,0,ImgW,ImgH,"Output"); 
      Start[2] = new Tab(5*ImgW,0,ImgW,ImgH,"Help");
      */
      Input[0]= new Tab(0,0,ImgW,ImgH,"Overview"); 	//input tabs
      Input[0].Alt(1);
      Input[1]= new Tab(ImgW,0,ImgW,ImgH,"Instructor"); 
      Input[2]= new Tab(2*ImgW,0,ImgW,ImgH,"Hw/Tests");
      Input[3]= new Tab(3*ImgW,0,ImgW,ImgH,"Class"); 
      Input[4]= new Tab(4*ImgW,0,ImgW,ImgH,"Book"); 
      Input[5]= new Tab(5*ImgW,0,ImgW,ImgH,"Finish"); 

      parent = mom;
      
      int w = ImgW*6;
      int h = ImgH+10;
      
      minSize = new Dimension(w,h);
      repaint();
      this.session = session;
      this.choice1=choice1;
    }

  public Dimension preferredSize() {
    return minimumSize();
  }
  
  public synchronized Dimension minimumSize() {
    return minSize;
  }
  
 
  public void paint (Graphics g) 
    {
//System.err.println("subclass paint");
      g.setFont (theFont);
      
      if (session==1)
	{
	  for (int i=0; i<6; i++)    //draw all of the unhighlighted tabs
	    if (i !=choice1)
	      Input[i].Draw(g);
	  Input[choice1].Draw(g);    //draw the highlighted tabs
	}
    }
}


//****************************************************************************************************



public class Evaluation extends Applet
{

  public Form1 form;
  public ImageCanvas canvas;

  public GridBagLayout gridbag = new GridBagLayout();
  public Panel panel;


  int session;		// menu (tab) options


  public void init()
    {
      session=1;

      canvas  = new ImageCanvas(this, session, 0);
      form = new Form1();

      panel = new Panel();
      panel.setLayout(gridbag);
      add("North", panel);
      
      constrain(panel, canvas, 0,0,1,1);
      constrain(panel, form, 0,1,1,1);
	
      repaint();
    }


  public boolean mouseUp(Event e, int x, int y)
    {
      //System.err.println("main mouseup " + y );
      if (y<canvas.ImgH)
	{
	  if (session==1)			// Input menus
	    {

	      canvas.Input[canvas.choice1].Alt(0);
	      canvas.choice2 = canvas.choice1;

	      for (int i=0; i<6; i++)		
		{
		  if (canvas.Input[i].Inside(x,y))
		    canvas.choice1 = i;
		}
	      canvas.Input[canvas.choice1].Alt(1);

	      form.Switch(canvas.choice1);
	    }
	  else					// output material
	    {}
	} 		                  // lower than menu height

      repaint();
      return true;      
    }
  

    public void update(Graphics g) 
    {
      //System.err.println("main update");
//      form.Switch(choice1);
      canvas.repaint();
      //System.err.println("through main update");
    }

  public void paint(Graphics g)
    {
      //System.err.println("main paint");
    }


  public void constrain(Container container, Component component, int grid_x,         //labels
			int grid_y, int grid_width, int grid_height)
    {
      constrain(container, component, grid_x, grid_y, grid_width, grid_height,
		GridBagConstraints.NONE, GridBagConstraints.WEST, 
		0.0, 0.0, 0, 20, 0, 0);
    }

  public void constrain(Container container, Component component, 
			int grid_x, int grid_y, int grid_width, 
			int grid_height, int fill, int anchor, 
			double weight_x, double weight_y, int top, int left,
			int bottom, int right)
    {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x; c.gridy=grid_y;
      c.gridwidth = grid_width; c.gridheight = grid_height;
      c.fill = fill; c.anchor = anchor;
      c.weightx = weight_x; c.weighty = weight_y;
      if (top+bottom+left+right>0)
	c.insets = new Insets(top,left,bottom,right);

      ((GridBagLayout)container.getLayout()).setConstraints(component,c);
      container.add(component);
    }

}

