#! /usr/bin/perl

Note: do tables have to hold max amount of fields? How does that work? (books)
#include msql.h    # Note: written in C or Perl?  Would like to write this in 
                  #perl so that I can include it in the existing program & port

# need to run msqladmin to create db_name;

################################################
# global parameters
################################################

$connected = 0;		#set to true if get grades automatically
$use_grades = 1;       # if attached to U, can separate according to student grade
$host  = "galaxy.cs.umn.edu";
$DATA_MAX = 45;
$THIS_YR = 1997; # add date thing
$db_name = "InstrEval";


################################################
# main function
################################################

$socket = msqlConnect($host) ;                #connect to host
if ($socket < 0)	{
    print "Connection failed \n";
    exit;
}

if (msqlSelectDB($socket, $db_name) < 0) {        #get database
    print "DB prob: $msqlErrMsg \n";
    exit;
}
	
#choose subroutine
if ($choice=="init") {
    &init; }
elsif ($choice=="history") {
    &history; }
elsif ($choice=="add_data") {
    &add_data; }
elsif ($choice=="adjust_predictions") {
    &adjust_predictions; }
elsif ($choice=="convert") {
    &convert; }
else {
    &gen_forms; }

msqlClose($socket);

#################################################
# init
#################################################
# 
# if this can be run from here, this is the file which sets up everything
#
sub init()
{
    msqlQuery( $socket, "CREATE TABLE instructor_data (
		first_name	char(15) not null,
		last_name	char(20) not null,
		gender		char(1) not null,
		yr_last		int,
		image_name	char(12) 
	)"); #     _seq

    msqlQuery( $socket, "CREATE SEQUENCE ON TABLE instructor_data STEP 1 			VALUE 1");
    msqlQuery( $socket, "CREATE INDEX instr_ind_2 ON instructor_data (first_name, 		last_name)");

    msqlQuery( $socket, "CREATE TABLE room_data (
		room_no	char(8) not null,
		bldg_abbrev	char(10) not null,
		yr_last		int
	)");

    msqlQuery( $socket, "CREATE SEQUENCE ON TABLE room_data STEP 1 VALUE 1");
    msqlQuery( $socket, "CREATE INDEX room_ind_2 ON room_data (bldg_abbrev, room_no)");
    

    msqlQuery( $socket, "CREATE TABLE book_data (
		title		text(30) not null,
		publisher	text(20) not null,
		ISBN		char(15) not null,
		yr_last		int
	)");

    msqlQuery( $socket, "CREATE UNIQUE INDEX book_ind_1 ON book_data (ISBN)");
    
    msqlQuery( $socket, "CREATE TABLE class_data (
		dept		char(5) not null,
		class_no	int not null,
		ext		char(1),
		year		int not null,
		term		int not null,
		instr_id	int not null,
		room_id	int not null,
		book_1	char(15),
		book_2	char(15),
		book_3	char(15),
		yr_last		int
	)");

    msqlQuery( $socket, "CREATE SEQUENCE ON TABLE class_data STEP 1 VALUE 1");
    msqlQuery( $socket, "CREATE UNIQUE INDEX class_id ON class_data (dept, class_no, ext, year, term)");


	msqlQuery( $socket, "CREATE TABLE student_data (
		student_id	int not null,
		class_id	int not null,
	)");

	msqlQuery( $socket, "CREATE SEQUENCE ON TABLE student_data STEP 1 VALUE 1");
	msqlQuery( $socket, "CREATE UNIQUE INDEX student_ind_1 ON student_data (student_id, class_id)");

	msqlQuery( $socket, "CREATE TABLE form_data (
		stu-class_id	int, 	# prevents multiple forms
		registered	char(1),
		grade		char(2),
		data		char(45) not null,
		i_grade	char(2) not null,
		i_grade_est	char(2) not null,
		t_grade	char(2) not null,
		t_grade_est	char(2) not null
	)");

	msqlQuery( $socket, "CREATE UNIQUE INDEX form_ind_1 ON form_data (stu-class_id)");


	msqlQuery( $socket, "CREATE TABLE shoot_data (
		stu-class_id	int not null,
		registered	char(1),
		week		int not null,
		score		int not null,
		good_junk	char(10),
		bad_junk	char(10)
	)");

	msqlQuery( $socket, "CREATE SEQUENCE ON TABLE shoot_data STEP 1 VALUE 1");
	msqlQuery( $socket, "CREATE UNIQUE INDEX shoot_ind_1 ON shoot_data (stu-class_id)");

}

#################################################
# add total
#################################################
#
# allows data to be added to the database through 3 ways
#
# 1) direct connection with U ... will have to be implemented by school, as I learn more, I 
# can simplify this.
# 2) information can be added item by item.  Appropriate forms added each time.
# 3) everything can be added using a flat file
#

sub add_total
{
    if ($connected)
    {
	#add connection to U stuff
    }
    else
    {
	&form_header;
	print qq~
	    A flat file can also be converted.  If you choose
		<INPUT TYPE=submit NAME=choice VALUE=convert><P>~;
	&form_footer;
	# include something that states that flat file can be added here
    }
    
    #better way to do this...?
    
    @tables = msqlListTables($socket, $db_name)
	for ($i=0; $i < $#db_name; $i++)
	{
	    $tables[$i]; #...?
	    foreach (table entered) -  result = msqlListTables(sock) {
		if (index exists from form_data) {
		    for each field in table -  results = msqlListFields(sock,tableName); 
		}}
	    if changed
		update -; #... 
	    else
		insert;
	}
				

    if ($instructor_junk)
    {
	$exists = msqlQuery($socket, "SELECT first_name, last_name, gender, yr_last, image_name FROM instructor_data WHERE first_name = $first_name and last_name = $last_name" );
	
	if ($exists)
	{
	    $match = msqlStoreResult();
	    $matchrow = msqlFetchRow($match);
	    if ($gender != "")
		$matchrow[2] = $gender;
	    if ($image_name != "")
		$matchrow[4] = $image_name;
	    if($matchrow[3] != THIS_YR)
		$matchrow[3] = $THIS_YR;
	    msqlQuery ($socket, "UPDATE instructor_data SET gender=$gender, yr_last = $yr_last, image_name=$image_name WHERE first_name = $first_name and last_name = $last_name");
	}
	else
	{
	    $success_row = msqlQuery ($socket, "INSERT INTO instructor_data 				VALUES $first_name, $last_name, $gender, $THIS_YR, 					$image_name");
	}
	
    }
    
}


###################################################
# history
###################################################
#
# history convertion program.  Will turn quarterly data into historical files.  
# if connected to the school, can be used to only include registered studets,
# or can include the student's grades.
# After being run through this, data is available for students.
#
sub history
{
    
    #convert shoot data
    if ($connected)
    {
	#sort & check each of the entries to find if student is registered
	# if need to minimize connection, do a query to get each student/class pair
	#and submit only unique queries
	
	msqlQuery( $socket, "DELETE FROM shoot_data WHERE 
		  registered <>'y' AND registered <> 'Y' ");
    }
    
    $numrows = msqlQuery($socket, "SELECT  student_data.class_id, shoot_data.week, shoot_data.score, shoot_data.good_junk, shoot_data.bad_junk FROM shoot_data, student_data WHERE shoot_data.stu-class.id = student_data.stu-class.id
ORDER BY student_data.class_id, shoot_data.week");

    $history = msqlStoreResult();
    
#shouldn't the row be an array??

    @currow = msqlFetchRow($history);
    if ($#currow == 0) {
	print "Error: $msqlErrorMsg"; }
    
    if ($currow[2] > 0)
	$posscore=$currow[2];
    else
	$negscore=$currow[2];
    @good_junk = split(|,$currow[3]);
    @bad_junk = $split(|,$currow[4]);

    if (($#good_junk != 10) || ($#bad_junk != 10)) {
	print "Error: not correct # of parameters";

	for ($i=0; $i<$numrows; $i++)
	{
	    $prevrow = $currow;
	    @currow = msqlFetchRow($history);
	    if ($#currow == 0) {
		print "Error: $msqlErrorMsg"; }
	    
	    if (($currow[0] == $prevrow[0]) && ($currow[1] == $prevrow[1]))
	    {
		if ($currow[2] > 0)
		    $posscore += $currow[2];
		else
		    $negscore += $currow[2];
		@good_junk += split(|,$currow[3]);
		@bad_junk += split(|,$currow[4]);
	    }
	    else
	    {
		# may need to separate good/bad_junk
		$success_row = msqlQuery ($socket, "INSERT INTO shoot_hist
		VALUES $prevrow[0], $prevrow[1], $posscore, $negscore, 					@good_junk, @bad_junk ");
		
		if ($currow[2] > 0)
		    $posscore=$currow[2];
		else
		    $negscore=$currow[2];
		@good_junk = split(|,$currow[3]);
		@bad_junk = split(|,$currow[4]);
	    }
	}			
	msqlFreeResult($history);


	#convert form data
	if ($connected)
	{
	    #get information, and fill in registered
	    msqlQuery( $socket, "DELETE FROM form_data 
	               WHERE registered <>'y' AND registered <> 'Y' ");
	}
	
	if ($use_grades)
	{
	    $numrows = msqlQuery($socket, "SELECT  student_data.class_id, form_data.grade, form_data.data, form_data.i_grade, form_data.t_grade, FROM form_data, student_data WHERE form_data.stu-class.id = student_data.stu-class.id ORDER BY student_data.class_id, form_data.grade");
	}

	$history = msqlStoreResult();

	# note, in future, could save range of values, not just average

	@currow = msqlFetchRow($history);
	if ($#currow == 0) {
	    print "Error: $msqlErrorMsg"; }


	@temp_tot = (int)split(|,$currow[2]); 
	for ($i=0; $i<$DATA_MAX; $i++)
	{
	    if ($temp_tot[$i] =~ /\D/)     #if it's a digit - not blank or NA
	    {
		$data_tot[$i] = $temp_tot[$i];
		$data_count[$i] = 1;
	    }
	    else
	    {
		$data_tot[$i] = 0;
		$data_count[$i]= 0;
	    }
	}
			
	$i_grade = (int)$currow[3];
	$ig_count = 1;
	$t_grade = (int)$currow[4];
	$tg_count = 1;

	for ($j=0; $j<$numrows; $j++)
	{
	    $prevrow = $currow;
	    @currow = msqlFetchRow($history);
	    if ($#currow == 0) {
		print "Error: $msqlErrorMsg"; }


	    if (($currow[0] == $prevrow[0]) && ($currow[1] == $prevrow[1]))
	    {
		@temp_tot = (int)split(|,$currow[2]); 
		for ($i=0; $i<$DATA_MAX; $i++)
		{
		    if ($temp_tot[$i] =~ /\D/)     #if it's a digit - not blank or NA
		    {
			$data_tot[$i] += $temp_tot[$i];
			$data_count[$i]++;
		    }
		    $i_grade += $currow[3];
		    $ig_count++;
		    $t_grade += $currow[4];
		    $tg_count++;
		}
		else  					# new entry into database
		{					# get averages
		    for ($i=0; $i<$DATA_MAX; $i++) {
			$real_tot = $data_tot[$i] /=$data_count[$i];
		    }
		    $real_i_grade = $i_grade / $ig_count;
		    $real_t_grade = $t_grade / $tg_count;
		    
		    # add data to database
		    $success_row = msqlQuery ($socket, "INSERT INTO form_hist
			VALUES $prevrow[0], $prevrow[1], $real_tot, $real_i_grade,
 			$real_t_grade");

		    @temp_tot = (int)split(|,$currow[2]); 
		    for ($i=0; $i<$DATA_MAX; $i++)
		    {
			if ($temp_tot[$i] =~ /\D/)     #if it's a digit - not blank or NA
			{
			    $data_tot[$i] = $temp_tot[$i];
			    $data_count[$i] = 1;
			}
			else
			{
			    $data_tot[$i] = 0;
			    $data_count[$i]= 0;
			}
		    }
		    
		    $i_grade = (int)$currow[3];
		    $ig_count = 1;
		    $t_grade = (int)$currow[4];
		    $tg_count = 1;
		}

	    }
	}			# finished rows of form database

	msqlFreeResult($history);
    }
    else   				#don't use grades!
    {
	$numrows = msqlQuery($socket, "SELECT  student_data.class_id, form_data.data, form_data.i_grade, form_data.t_grade FROM form_data, student_data WHERE form_data.stu-class.id = student_data.stu-class.id ORDER BY student_data.class_id");
	

	$history = msqlStoreResult();
	
	# note, in future, could save range of values, not just average
	
	@currow = msqlFetchRow($history);
	if ($#currow == 0) {
	    print "Error: $msqlErrorMsg"; }

	@temp_tot = (int)split(|, $currow[1]); 
	for ($i=0; $i<$DATA_MAX; $i++)
	{
	    if ($temp_tot[$i] =~ /\D/)     #if it's a digit - not blank or NA
	    {
		$data_tot[$i] = $temp_tot[$i];
		$data_count[$i] = 1;
	    }
	    else
	    {
		$data_tot[$i] = 0;
		$data_count[$i]= 0;
	    }
	}
			
	$i_grade = (int)$currow[2];
	$ig_count = 1;
	$t_grade = (int)$currow[3];
	$tg_count = 1;

	for ($j=0; $j<$numrows; $j++)
	{
	    $prevrow = $currow;
	    @currow = msqlFetchRow($history);
	    if ($#currow == 0) {
		print "Error: $msqlErrorMsg"; }
	    
	    if ($currow[0] == $prevrow[0])
	    {
		@temp_tot = (int)split(|, $currow[1]); 
		for ($i=0; $i<$DATA_MAX; $i++)
		{
		    if ($temp_tot[$i] =~ /\D/)     #if it's a digit - not blank or NA
		    {
			$data_tot[$i] += $temp_tot[$i];
			$data_count[$i]++;
		    }
		    $i_grade += $currow[2];
		    $ig_count++;
		    $t_grade += $currow[3];
		    $tg_count++;
		}
		else  					# new entry into database
		{					# get averages
		    for ($i=0; $i<$DATA_MAX; $i++) {
			$real_tot = $data_tot[$i] /= $data_count[$i];
		    }
		    $real_i_grade = $i_grade / $ig_count;
		    $real_t_grade = $t_grade / $tg_count;
		    
		    # add data to database
		    $success_row = msqlQuery ($socket, "INSERT INTO form_hist
		    VALUES $prevrow[0], $real_tot, $real_i_grade, $real_t_grade");

		    @temp_tot = (int)split(|, $currow[1]); 
		    for ($i=0; $i<$DATA_MAX; $i++)
		    {
			if ($temp_tot[$i] =~ /\D/)     #if it's a digit - not blank or NA
			{
			    $data_tot[$i] = $temp_tot[$i];
			    $data_count[$i] = 1;
			}
			else
			{
			    $data_tot[$i] = 0;
			    $data_count[$i]= 0;
			}
		    }
		    
		    $i_grade = (int)$currow[2];
		    $ig_count = 1;
		    $t_grade = (int)$currow[3];
		    $tg_count = 1;
		}
		
	    }
	}			# finished rows of form database
	
	msqlFreeResult($history);
	
    }
}

#################################################
# adjust predictions
#################################################
#
#
sub adjust_predictions
{
	# to be implemented later, this will allow programmers to put in an algorithm that
 	# would provide a closer estimate to predict final grades.  This also gives an 
	# idea of what questions are the most relevant ... great education junk
}

################################################
# convert
################################################
sub convert
{
    #subroutine to convert a flat file
    #
    # will use msqlimport - don't know if can do from here
    #
}

#################################################
# gen forms
#################################################
#
# generate necessary forms to allow data to be added.
#
sub gen_forms
{
# Note: need to set variable or something which says to insert data... how does this work?
    &form_header;
    if ($choice == "instructor")
    {
	print qq~
	    First Name: <INPUT TYPE=text NAME=first_name SIZE=30 
		MAXSIZE=50 VALUE=required><BR>
	    Last Name: <INPUT TYPE=text NAME=last_name SIZE=30
		MAXSIZE=50 VALUE=required><BR>
	    Gender: <INPUT TYPE=radio NAME=gender VAUE="m"> Male
		<INPUT TYPE=radio NAME=gender VAUE="f"> Female<BR>
		<INPUT TYPE=text NAME=yr_last VALUE=$THIS_YR>
	    Image Name: <INPUT TYPE=text NAME=image_name SIZE=30
		MAXSIZE=50><BR>~;
    }
    elsif ($choice == "room")
    {
	print qq~
	    Building (abbrev): <INPUT TYPE=text NAME=bldg_abbrev SIZE=10
		MAXSIZE=10 VALUE=required><BR>
	    Room Number: <INPUT TYPE=text NAME=room_no SIZE=8
		MAXSIZE=8 VALUE=required><BR>
	        <INPUT TYPE=text NAME=yr_last VALUE=$THIS_YR>~;
    }
    elsif ($choice == "book")
    {
	print qq~
	Title: <INPUT TYPE=text NAME=title SIZE=30
	    MAXSIZE=60 VALUE=required><BR>
	Publisher: <INPUT TYPE=text NAME=publisher SIZE=20
	    MAXSIZE=50 VALUE=required><BR>
	ISBN: <INPUT TYPE=text NAME="ISBN" SIZE=15
	    MAXSIZE=15 VALUE=required><BR>
	    <INPUT TYPE=text NAME=yr_last VALUE=$THIS_YR>~;
    }
    elsif ($choice == "class")
    {
	print qq~
	  Dept: <INPUT TYPE=text NAME=dept SIZE=5
	      MAXSIZE=5 VALUE=req.><BR>
	  Room Number: <INPUT TYPE=text NAME=class_no SIZE=6
	      MAXSIZE=8 VALUE=req.><BR>
	  Extension? <INPUT TYPE=checkbox NAME=ext><BR>
	  Year (4 digits): <INPUT TYPE=text NAME=year SIZE=4
	      MAXSIZE=4><BR>
	  Term: <INPUT TYPE=text NAME="term" SIZE=2
	      MAXSIZE=2> Fall=1, Winter=2, ...<BR>

	 <hr width=80%>

	  Who''s teaching it?<BR>
	  First Name: <INPUT TYPE=text NAME=first_name SIZE=30
	      MAXSIZE=50 VALUE=required><BR>
	  Last Name: <INPUT TYPE=text NAME=last_name SIZE=30
	      MAXSIZE=50 VALUE=required><BR>

	  <hr width=80%>

	  What classroom?<BR>
	  Building (abbrev): <INPUT TYPE=text NAME=bldg_abbrev SIZE=10
	      MAXSIZE=10 VALUE=required><BR>
	  Room Number: <INPUT TYPE=text NAME=room_no SIZE=8
	      MAXSIZE=8 VALUE=required><BR>

	  <hr width=80%>

	  Which Textbook is required?<BR>

	  Title: <INPUT TYPE=text NAME=title SIZE=30
	      MAXSIZE=60 VALUE=required><BR>
	  Publisher: <INPUT TYPE=text NAME=publisher SIZE=20
	      MAXSIZE=50 VALUE=required><BR>
	  <INPUT TYPE=text NAME=yr_last VALUE=$THIS_YR>~;
    }
    &form_footer;
}

#################################################
# form header
#################################################
#
sub form_header
{
#add stuff from Selena's junk
<FORM METHOD=get ACTION="eval.cgi">

}

#################################################
# form footer
#################################################
#
sub form_footer
{
    print qq~
	Choose appropriate button to keep adding, or click "DONE"<BR>
	<INPUT TYPE=submit NAME="choice" VALUE="instructor">
	<INPUT TYPE=submit NAME="choice" VALUE="room">
	<INPUT TYPE=submit NAME="choice" VALUE="book">
	<INPUT TYPE=submit NAME="choice" VALUE="class">
	<INPUT TYPE=submit NAME="choice" VALUE="DONE"><BR>
	</FORM></BODY></HTML>~;
}

