import java.awt.*;
import java.awt.image.ImageObserver;
import java.net.*;


public class ProfCanvas extends Canvas {  
  int FONTSIZE=28;
  Font f = new Font("Helvetica", Font.BOLD,FONTSIZE);
  Container parent;
  Image Prof;
  boolean trueSizeKnown = false;
  Dimension minSize;
  int w, h;

  Image Star, Splat, ImgChoice = null;
  int currx, curry;
  int score=0;


  public ProfCanvas(Image targetimage, Container dad, 
		   int Width, int Height) 
    {
      Prof = targetimage;
      parent = dad;
      
      w = Width;
      h = Height;
      
      minSize = new Dimension(w,h);
      repaint();
     }

  public Dimension preferredSize() {
    return minimumSize();
  }

  public synchronized Dimension minimumSize() {
    return minSize;
  }

  public boolean mouseDown(Event evt, int x, int y)  //mouse down, but not on button
    {
      currx = x; 
      curry = y;
      
      if(ImgChoice !=null)                             //if they've chosen an image
	{
	  if(ImgChoice == Splat)                     //choice of bad image
	    score--;
	  else                                         //choice of good image
	    score++;	
	  
	  repaint();
	}

      return false;                 //force it to continue to the Rater code
    }

  public void destroy() 
    {
      Prof.flush();
      Star.flush();
      Splat.flush();
    }

 public void update(Graphics g)
    {
      paint(g); 
    }

 
    public void paint (Graphics g) 
    {
      int RECWIDTH;
      g.setColor(Color.black);
      g.setFont(f);
      if (Prof != null) {
	if(ImgChoice == null)           //very first time, draw image
	  {
	    g.drawImage(Prof, 0, 0, this);
	    g.drawRect(0, 0, w - 1, h - 1);
	  }
	else
	  {
	    //set up different cases
	    // 1 digit, 0-9
	    // 2 digits, -1 - -9, 10-99
	    // 3 digits -10 - -99, 100-999
	    // 4 digits for those students overly-excitable.
	    if (score>-1 && score < 10)     
	      RECWIDTH=121;
	    else if ((score>-10 && score<0) || (score>9 && score<100))
	      RECWIDTH=138;
	    else if (score>99 || (score>-100 && score<-9))           
	      RECWIDTH=155;
	    else
	      RECWIDTH=172;                                          

	    g.setColor(Color.white);                      //scorebox
	    g.fillRect((w-RECWIDTH)/2, h-FONTSIZE, RECWIDTH, h);
	    
	    g.setColor(Color.red);
	    g.drawString("Score: "+score,(w-RECWIDTH+12)/2, h);
	    g.drawImage(ImgChoice, currx - ImgChoice.getWidth(this)/2, 
			curry - ImgChoice.getHeight(this)/2, this); 
	  }
      }
    }
}
